local AddOn, NS = ...
local ToTemInit, Settings

local function MoveTotem()
	if not Settings then return end
--	NS:DUF_Set_ElementPosition(TotemFrame, DUF_FRAME_DATA["player"].frame, Settings)
	if Settings.hide then
		TotemFrame:OldClearAllPoints()
		TotemFrame:OldSetPoint("RIGHT", UIParent, "LEFT", -100)
	else
		local attachframe = DUF_FRAME_DATA["player"].frame..Settings.attach
		if (Settings.attach == "Unit Frame") then
			attachframe = DUF_FRAME_DATA["player"].frame
		elseif (Settings.attach == "UIParent") then
			attachframe = "UIParent"
		end
--		local attached = select(2, _G[attachframe]:GetPoint(1))
--attachframe = _G[attachframe]
--print(attachframe, attachframe:GetName())
--		if attached == TotemFrame then -- OLD (currently in use like ["Default"]) setting has attachframe SetPointed to THIS frame we should clear it 
--			_G[attachframe]:ClearAllPoints() -- (Unless there's a bug in the Saved Variables this should clear up when the attachframe is configured later)
--		end
		TotemFrame:OldClearAllPoints()
		TotemFrame:OldSetPoint(Settings.attachpoint, attachframe, Settings.attachto, Settings.xoffset, Settings.yoffset)
	end
end

local function MoveTotemClassic()
	if not Settings then return end
--	NS:DUF_Set_ElementPosition(TotemFrame, DUF_FRAME_DATA["player"].frame, Settings)
	if Settings.hide then
		TotemFrame:ClearAllPoints()
		TotemFrame:SetPoint("RIGHT", UIParent, "LEFT", -100)
	else
		local attachframe = DUF_FRAME_DATA["player"].frame..Settings.attach
		if (Settings.attach == "Unit Frame") then
			attachframe = DUF_FRAME_DATA["player"].frame
		elseif (Settings.attach == "UIParent") then
			attachframe = "UIParent"
		end
--		local attached = select(2, _G[attachframe]:GetPoint(1))
--attachframe = _G[attachframe]
--print(attachframe, attachframe:GetName())
--		if attached == TotemFrame then -- OLD (currently in use like ["Default"]) setting has attachframe SetPointed to THIS frame we should clear it 
--			_G[attachframe]:ClearAllPoints() -- (Unless there's a bug in the Saved Variables this should clear up when the attachframe is configured later)
--		end
		TotemFrame:ClearAllPoints()
		TotemFrame:SetPoint(Settings.attachpoint, attachframe, Settings.attachto, Settings.xoffset, Settings.yoffset)
	end
end


local function CreateOverlay(totem, index, ignorepoints)
	local f = CreateFrame("Frame", "DUF_TotemFrame_Overlay_"..index)
	if not ignorepoints then
		f:SetAllPoints(totem)
	else
		f:SetAlpha(0.5)
	end
	f.Texture = f:CreateTexture("$parentTexture", "OVERLAY")
	f.Texture:SetAllPoints()
	f.Texture:SetTexture("Interface\\AddOns\\DiscordUnitFrames\\Icons\\Buff")
	return f
end

local function SetTotemPos(totem, index, last, point, toPoint, spacingX, spacingY)
	totem:ClearAllPoints()
	if index == 1 then
		totem:SetPoint("LEFT", TotemFrame)
	else
		totem:SetPoint(point, last, toPoint, spacingX, spacingY)
	end
end

local function ToTemEvent(self)
	local last
	local point, toPoint, spacingX, spacingY = NS:DUF_Get_Direction(Settings)
	local Count = 0
	for totem,_ in TotemFrame.totemPool:EnumerateActive() do
		Count = Count + 1
		SetTotemPos(totem, Count, last, point, toPoint, spacingX, spacingY)
		if totem.duration then
			totem.duration:ClearAllPoints()
			totem.duration:SetPoint("TOP", totem, "BOTTOM", 0, -0.5)
		end
		if Settings.scale then
			totem:SetScale(Settings.scale)
		end
		last = k
	end
end

function DUF_Initialize_TotemFrame(config)
	Settings = DUF_Settings[DUF_INDEX].player.TotemFrame
	if TotemFrame.totemPool then -- Dragonflight
		if not ToTemInit then
			ToTemInit = true
			hooksecurefunc(TotemFrame, "Update", ToTemEvent)
			TotemFrame.OldClearAllPoints = TotemFrame.ClearAllPoints
			TotemFrame.OldSetPoint = TotemFrame.SetPoint
			TotemFrame.OldSetSize = TotemFrame.SetSize
			TotemFrame.OldSetWidth = TotemFrame.SetWidth
			TotemFrame.OldSetHeight = TotemFrame.SetHeight
			TotemFrame.OldSetScale = TotemFrame.SetScale
	
			TotemFrame.ClearAllPoints = function() end
			TotemFrame.SetPoint = function() end
			TotemFrame.SetSize = function() end
			TotemFrame.SetWidth = function() end
			TotemFrame.SetHeight = function() end
			TotemFrame.SetScale = function() end
			
			TotemFrame.Layout = function() end
			if TotemFrame:GetParent() ~= UIParent then
				TotemFrame:SetParent(UIParent)
			end
	
			TotemFrame:OldSetSize(20, 20)
		end
--		point, toPoint, spacingX, spacingY = NS:DUF_Get_Direction(Settings)
		MoveTotem()
		if config then
			if not TotemFrame.OL then
				TotemFrame.OL = {}
				for i=1, 4 do
					local t = CreateOverlay(TotemFrame.OL, i, true)
					t:SetSize(15, 15)
					tinsert(TotemFrame.OL, t)
				end
			end
			local point, toPoint, spacingX, spacingY = NS:DUF_Get_Direction(Settings)
			local last
			for k, v in ipairs(TotemFrame.OL) do
				SetTotemPos(v, k, last, point, toPoint, spacingX, spacingY)
				v:SetScale(Settings.scale)
				v:Show()
				last = v
			end
		else
			if TotemFrame.OL then
				for k, v in ipairs(TotemFrame.OL) do
					v:Hide()
				end
			end
		end
	else
		local point, toPoint, spacingX, spacingY = NS:DUF_Get_Direction(Settings)
		for i = 1, MAX_TOTEMS do
			local totem = _G["TotemFrameTotem"..i]
			totem:ClearAllPoints()
			if i == 1 then
				totem:SetPoint(point, TotemFrame, 0, 0)
			else
				totem:SetPoint(point, _G["TotemFrameTotem"..i-1], toPoint, spacingX, spacingY)
			end
			if not totem.duration then
				totem.duration = _G[totem:GetName().."Duration"]
			end
			totem.duration:ClearAllPoints()
			totem.duration:SetPoint("TOP", totem, "BOTTOM", 0, -0.5)
			if Settings.scale then
				totem:SetScale(Settings.scale)
			end
			local f = _G["DUF_TotemFrame_Overlay_"..i]
			if config then
				if not f then
					f = CreateOverlay(totem, i)
				end
				f:Show()
			else
				if f then
					f:Hide()
				end
			end
		end
		if not ToTemInit then
			ToTemInit = true
			hooksecurefunc("TotemFrame_Update", MoveTotemClassic)
		end
		MoveTotemClassic()
	end
end
